package com.ruoyi.system.domain.task;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TkCommonReportExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public TkCommonReportExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdIsNull() {
            addCriterion("common_tk_id is null");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdIsNotNull() {
            addCriterion("common_tk_id is not null");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdEqualTo(String value) {
            addCriterion("common_tk_id =", value, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdNotEqualTo(String value) {
            addCriterion("common_tk_id <>", value, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdGreaterThan(String value) {
            addCriterion("common_tk_id >", value, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdGreaterThanOrEqualTo(String value) {
            addCriterion("common_tk_id >=", value, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdLessThan(String value) {
            addCriterion("common_tk_id <", value, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdLessThanOrEqualTo(String value) {
            addCriterion("common_tk_id <=", value, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdLike(String value) {
            addCriterion("common_tk_id like", value, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdNotLike(String value) {
            addCriterion("common_tk_id not like", value, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdIn(List<String> values) {
            addCriterion("common_tk_id in", values, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdNotIn(List<String> values) {
            addCriterion("common_tk_id not in", values, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdBetween(String value1, String value2) {
            addCriterion("common_tk_id between", value1, value2, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andCommonTkIdNotBetween(String value1, String value2) {
            addCriterion("common_tk_id not between", value1, value2, "commonTkId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdIsNull() {
            addCriterion("report_user_id is null");
            return (Criteria) this;
        }

        public Criteria andReportUserIdIsNotNull() {
            addCriterion("report_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andReportUserIdEqualTo(String value) {
            addCriterion("report_user_id =", value, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdNotEqualTo(String value) {
            addCriterion("report_user_id <>", value, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdGreaterThan(String value) {
            addCriterion("report_user_id >", value, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("report_user_id >=", value, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdLessThan(String value) {
            addCriterion("report_user_id <", value, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdLessThanOrEqualTo(String value) {
            addCriterion("report_user_id <=", value, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdLike(String value) {
            addCriterion("report_user_id like", value, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdNotLike(String value) {
            addCriterion("report_user_id not like", value, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdIn(List<String> values) {
            addCriterion("report_user_id in", values, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdNotIn(List<String> values) {
            addCriterion("report_user_id not in", values, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdBetween(String value1, String value2) {
            addCriterion("report_user_id between", value1, value2, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserIdNotBetween(String value1, String value2) {
            addCriterion("report_user_id not between", value1, value2, "reportUserId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdIsNull() {
            addCriterion("report_user_role_id is null");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdIsNotNull() {
            addCriterion("report_user_role_id is not null");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdEqualTo(String value) {
            addCriterion("report_user_role_id =", value, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdNotEqualTo(String value) {
            addCriterion("report_user_role_id <>", value, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdGreaterThan(String value) {
            addCriterion("report_user_role_id >", value, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdGreaterThanOrEqualTo(String value) {
            addCriterion("report_user_role_id >=", value, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdLessThan(String value) {
            addCriterion("report_user_role_id <", value, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdLessThanOrEqualTo(String value) {
            addCriterion("report_user_role_id <=", value, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdLike(String value) {
            addCriterion("report_user_role_id like", value, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdNotLike(String value) {
            addCriterion("report_user_role_id not like", value, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdIn(List<String> values) {
            addCriterion("report_user_role_id in", values, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdNotIn(List<String> values) {
            addCriterion("report_user_role_id not in", values, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdBetween(String value1, String value2) {
            addCriterion("report_user_role_id between", value1, value2, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andReportUserRoleIdNotBetween(String value1, String value2) {
            addCriterion("report_user_role_id not between", value1, value2, "reportUserRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdIsNull() {
            addCriterion("top_leader_role_id is null");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdIsNotNull() {
            addCriterion("top_leader_role_id is not null");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdEqualTo(String value) {
            addCriterion("top_leader_role_id =", value, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdNotEqualTo(String value) {
            addCriterion("top_leader_role_id <>", value, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdGreaterThan(String value) {
            addCriterion("top_leader_role_id >", value, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdGreaterThanOrEqualTo(String value) {
            addCriterion("top_leader_role_id >=", value, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdLessThan(String value) {
            addCriterion("top_leader_role_id <", value, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdLessThanOrEqualTo(String value) {
            addCriterion("top_leader_role_id <=", value, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdLike(String value) {
            addCriterion("top_leader_role_id like", value, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdNotLike(String value) {
            addCriterion("top_leader_role_id not like", value, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdIn(List<String> values) {
            addCriterion("top_leader_role_id in", values, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdNotIn(List<String> values) {
            addCriterion("top_leader_role_id not in", values, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdBetween(String value1, String value2) {
            addCriterion("top_leader_role_id between", value1, value2, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTopLeaderRoleIdNotBetween(String value1, String value2) {
            addCriterion("top_leader_role_id not between", value1, value2, "topLeaderRoleId");
            return (Criteria) this;
        }

        public Criteria andTolevelIsNull() {
            addCriterion("tolevel is null");
            return (Criteria) this;
        }

        public Criteria andTolevelIsNotNull() {
            addCriterion("tolevel is not null");
            return (Criteria) this;
        }

        public Criteria andTolevelEqualTo(String value) {
            addCriterion("tolevel =", value, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelNotEqualTo(String value) {
            addCriterion("tolevel <>", value, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelGreaterThan(String value) {
            addCriterion("tolevel >", value, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelGreaterThanOrEqualTo(String value) {
            addCriterion("tolevel >=", value, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelLessThan(String value) {
            addCriterion("tolevel <", value, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelLessThanOrEqualTo(String value) {
            addCriterion("tolevel <=", value, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelLike(String value) {
            addCriterion("tolevel like", value, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelNotLike(String value) {
            addCriterion("tolevel not like", value, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelIn(List<String> values) {
            addCriterion("tolevel in", values, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelNotIn(List<String> values) {
            addCriterion("tolevel not in", values, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelBetween(String value1, String value2) {
            addCriterion("tolevel between", value1, value2, "tolevel");
            return (Criteria) this;
        }

        public Criteria andTolevelNotBetween(String value1, String value2) {
            addCriterion("tolevel not between", value1, value2, "tolevel");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}